















-- Analog Audio Input (TAS3308 ADC in)
--
-- Property values of this instance:
-- InstanceId: TAS3308ADCIn_1
-- OutputChannels: 2

-- Port definitions for ADC In
.port TAS3308ADCIn_1.Ch1_Out  ADCL_D
.port TAS3308ADCIn_1.Ch2_Out  ADCR_D

--  Copyright (c) Texas Instruments, Inc.  2006
--  Author:     Shawn Brooks
--  Date:       10/18/06

--  Version:    3

--
-- Property values of this instance:
-- InstanceId: Split2Ch_1
-- OutputChannels: 4

-- 2 input, up to 8 channel output splitter
-- Splitter Type: 1

-- Port definitions mapping the component ports to variables
.port Split2Ch_1.Ch1_In         Split2Ch_1_SplitIn1_D
.port Split2Ch_1.Ch2_In         Split2Ch_1_SplitIn2_D
.port Split2Ch_1.Ch1_Out        Split2Ch_1_SplitOut1_D
.port Split2Ch_1.Ch2_Out        Split2Ch_1_SplitOut2_D

.port Split2Ch_1.Ch3_Out        Split2Ch_1_SplitOut3_D
.port Split2Ch_1.Ch4_Out        Split2Ch_1_SplitOut4_D


.data Split2Ch_1_SplitOut3_D
.data Split2Ch_1_SplitOut4_D



-- Data
.data Split2Ch_1_SplitIn1_D
.data Split2Ch_1_SplitIn2_D
.data Split2Ch_1_SplitOut1_D
.data Split2Ch_1_SplitOut2_D


NOP | NOP | LD(Split2Ch_1_SplitIn1_D,B) | NOP | NOP                                           
NOP | NOP | LD(Split2Ch_1_SplitIn2_D,L) | NOP | ST(B,DATA,Split2Ch_1_SplitOut1_D)
NOP | NOP | NOP                                      | NOP | ST(L,DATA,Split2Ch_1_SplitOut2_D)
NOP | NOP | NOP                                      | NOP | ST(B,DATA,Split2Ch_1_SplitOut3_D)
NOP | NOP | NOP                                      | NOP | ST(L,DATA,Split2Ch_1_SplitOut4_D)
NOP | NOP | NOP                                      | NOP | NOP


 


-- Property values of this instance:
-- InstanceId: TAS2Delay_1
-- InputChannels: 1


.port TAS2Delay_1.Ch1_In         TAS2Delay_1_In1_D
.port TAS2Delay_1.Ch1_Out         TAS2Delay_1_Out1_D
.data TAS2Delay_1_In1_D
.data TAS2Delay_1_Out1_D

CLRACC  | NOP                   | LD(TAS2Delay_1_In1_D, B)            | NOP | NOP
THRU(B) | NOP                   | NOP                                 | NOP | NOP
NOP     | ADD(BR,ZERO,CLP32,B) | NOP                                 | NOP | NOP
THRU(B) | NOP                   | NOP                                 | NOP | NOP
NOP     | ADD(BR,ZERO,NONE,L)   | NOP                                 | NOP | NOP


THRU(L) | NOP                   | NOP                                 | NOP | NOP
NOP     | ADD(ACC,LR,NONE,DLYI) | NOP                                 | NOP | DLYPTR(0)
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | ST(DLYO,DATA,TAS2Delay_1_Out1_D)

NOP     | NOP                   | NOP                                 | NOP | NOP                                              

    

--  Copyright (c) Texas Instruments, Inc.  2006
--  Author:     Venkat
--  Modified Date: 07/16/07

--  Version:    1

--  Mix 2-4 to 1 DSP  assembly code
--
-- Property values of this instance:
-- InstanceId: Mix4Ch_1
-- InputChannels: 2

-- 2-4 input, 1 output variable mixer

-- Coefficient Space Used	=	Channels
-- Data Space Used			=	1 + Channels
-- Code Space Used			=	3 + Channels
-- Cycle Count				=	3 + Channels

.port Mix4Ch_1.Ch1_In         Mix4Ch_1_MixIn1_D
.data Mix4Ch_1_MixIn1_D

.port Mix4Ch_1.Ch2_In         Mix4Ch_1_MixIn2_D
.data Mix4Ch_1_MixIn2_D



.coef Mix4Ch_1_MixGain1 @129   =0.5F	-- Mapped to I2C register 33
.coef Mix4Ch_1_MixGain2 @129+1 =0.5F	-- Mapped to I2C register 33

.port Mix4Ch_1.Ch1_Out        Mix4Ch_1_MixOut1_D
.data Mix4Ch_1_MixOut1_D
	
NOP | CLRACC               | LD(Mix4Ch_1_MixIn1_D,MD) | LD(Mix4Ch_1_MixGain1,MC) | NOP
NOP | NOP                  | LD(Mix4Ch_1_MixIn2_D,MD) | LD(Mix4Ch_1_MixGain2,MC) | NOP



NOP | ADD(ACC,MR,NONE,ACC) | NOP                                     | NOP                                     | NOP
NOP | ADD(ACC,MR,NONE,B)   | NOP                                     | NOP                                     | NOP
NOP | NOP                  | NOP                                     | NOP                                     | ST(B,DATA,Mix4Ch_1_MixOut1_D)
NOP | NOP | NOP | NOP | NOP


-- Property values of this instance:
-- InstanceId: TAS2Delay_2
-- InputChannels: 1


.port TAS2Delay_2.Ch1_In         TAS2Delay_2_In1_D
.port TAS2Delay_2.Ch1_Out         TAS2Delay_2_Out1_D
.data TAS2Delay_2_In1_D
.data TAS2Delay_2_Out1_D

CLRACC  | NOP                   | LD(TAS2Delay_2_In1_D, B)            | NOP | NOP
THRU(B) | NOP                   | NOP                                 | NOP | NOP
NOP     | ADD(BR,ZERO,CLP32,B) | NOP                                 | NOP | NOP
THRU(B) | NOP                   | NOP                                 | NOP | NOP
NOP     | ADD(BR,ZERO,NONE,L)   | NOP                                 | NOP | NOP


THRU(L) | NOP                   | NOP                                 | NOP | NOP
NOP     | ADD(ACC,LR,NONE,DLYI) | NOP                                 | NOP | DLYPTR(1)
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | NOP
NOP     | NOP                   | NOP                                 | NOP | ST(DLYO,DATA,TAS2Delay_2_Out1_D)

NOP     | NOP                   | NOP                                 | NOP | NOP                                              

    

--  Copyright (c) Texas Instruments, Inc.  2006
--  Author:     Venkat
--  Modified Date: 07/16/07

--  Version:    1

--  Mix 2-4 to 1 DSP  assembly code
--
-- Property values of this instance:
-- InstanceId: Mix4Ch_2
-- InputChannels: 2

-- 2-4 input, 1 output variable mixer

-- Coefficient Space Used	=	Channels
-- Data Space Used			=	1 + Channels
-- Code Space Used			=	3 + Channels
-- Cycle Count				=	3 + Channels

.port Mix4Ch_2.Ch1_In         Mix4Ch_2_MixIn1_D
.data Mix4Ch_2_MixIn1_D

.port Mix4Ch_2.Ch2_In         Mix4Ch_2_MixIn2_D
.data Mix4Ch_2_MixIn2_D



.coef Mix4Ch_2_MixGain1 @133   =0.5F	-- Mapped to I2C register 34
.coef Mix4Ch_2_MixGain2 @133+1 =0.5F	-- Mapped to I2C register 34

.port Mix4Ch_2.Ch1_Out        Mix4Ch_2_MixOut1_D
.data Mix4Ch_2_MixOut1_D
	
NOP | CLRACC               | LD(Mix4Ch_2_MixIn1_D,MD) | LD(Mix4Ch_2_MixGain1,MC) | NOP
NOP | NOP                  | LD(Mix4Ch_2_MixIn2_D,MD) | LD(Mix4Ch_2_MixGain2,MC) | NOP



NOP | ADD(ACC,MR,NONE,ACC) | NOP                                     | NOP                                     | NOP
NOP | ADD(ACC,MR,NONE,B)   | NOP                                     | NOP                                     | NOP
NOP | NOP                  | NOP                                     | NOP                                     | ST(B,DATA,Mix4Ch_2_MixOut1_D)
NOP | NOP | NOP | NOP | NOP

-- Copyright (c) Texas Instruments, Inc.  2006, 2007

-- Author:  Optimized by Yu Tang
-- Date:		11/12/2007
-- Version:	3

-- Tone control DSP assembly code
--
-- Property values of this instance:
-- InstanceId: 	Tone_1
-- InputChannels: 		2
--
-- The original code need 223 cycle counts + (24 cycles per channel)
-- New code need					 87 cycle counts + (20 cycles per channel)
-- The data and coef memory ussage also were reduced.
-- 
-- Data Memory used: 33 words
-- Coef Memory used: 42 words
-- Code Memory used: 211 words

.commondata onetenth =0x0000000CCCCC  -- 1/10
.data Tone_1_x         =0x0000000CCCCC  -- A0/10
.coef Tone_1_ro        =0x00800000     -- intermediate reciprocal value

-- Begin Cut (CUT) and Boost (BST) Biquad Coefficients (I2C Interface)

.coef  Tone_1_TREBLEA1   =0x00000000       
.coef  Tone_1_TREBLEA2   =0x00000000       
.coef  Tone_1_TREBLEB0   =0x00000000    
.coef  Tone_1_TREBLEB1   =0x00000000       
.coef  Tone_1_TREBLEB2   =0x00000000  

.coef  Tone_1_BASSA1     =0x00000000       
.coef  Tone_1_BASSA2     =0x00000000       
.coef  Tone_1_BASSB0     =0x00000000    
.coef  Tone_1_BASSB1     =0x00000000       
.coef  Tone_1_BASSB2     =0x00000000       


-- Include a set of filter coefficients for Bass:50Hz-150Hz, Treble:5KHz-15KHz
-- 48Ksps
-- Bass @ 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150 Hz
-- Treble@ 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15KHz
-- Type: EQ

-- fs 48KHz

-- 32Ksps
-- Bass @ 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150 Hz
-- Treble@ 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15KHz
-- Type: EQ

-- fs 32KHz

-- 44.1Ksps
-- Bass @ 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150 Hz
-- Treble@ 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15KHz
-- Type: EQ

-- Bass filter coefficients for fc = 50Hz to 150Hz
-- fc=50Hz, fs = 44.1Ksps
.coef  Tone_1_BBQCUTA0   =0x00815AB4
.coef  Tone_1_BBQCUTA1   =0x00FF15BC
.coef  Tone_1_BBQCUTA2   =0xFF824350
.coef  Tone_1_BBQCUTB0   =0x00800000
.coef  Tone_1_BBQCUTB1   =0xFF00EA44
.coef  Tone_1_BBQCUTB2   =0x007F1765
       
.coef  Tone_1_BBQBSTA0   =0x00800000
.coef  Tone_1_BBQBSTA1   =0x00FF15BC
.coef  Tone_1_BBQBSTA2   =0xFF80E89B
.coef  Tone_1_BBQBSTB0   =0x00815AB4
.coef  Tone_1_BBQBSTB1   =0xFF00EA44
.coef  Tone_1_BBQBSTB2   =0x007DBCB0
-- fc=60Hz, fs = 44.1Ksps
-- fc=70Hz, fs = 44.1Ksps
-- fc=80Hz, fs = 44.1Ksps
-- fc=90Hz, fs = 44.1Ksps
-- fc=100Hz, fs = 44.1Ksps
-- fc=110Hz, fs = 44.1Ksps
-- fc=120Hz, fs = 44.1Ksps
-- fc=130Hz, fs = 44.1Ksps
-- fc=140Hz, fs = 44.1Ksps
-- fc=150Hz, fs = 44.1Ksps

-- Treble filter coefficients for fc = 5 to 15KHz
-- fc = 5KHz, fs = 44.1Ksps
.coef  Tone_1_TBQCUTA0   =0x00E778BC
.coef  Tone_1_TBQCUTA1   =0x008D34C2
.coef  Tone_1_TBQCUTA2   =0x002CE405
.coef  Tone_1_TBQCUTB0   =0x00800000
.coef  Tone_1_TBQCUTB1   =0xFF72CB3E
.coef  Tone_1_TBQCUTB2   =0x003A94B6
       
.coef  Tone_1_TBQBSTA0   =0x00800000
.coef  Tone_1_TBQBSTA1   =0x008D34C2
.coef  Tone_1_TBQBSTA2   =0xFFC56B4A
.coef  Tone_1_TBQBSTB0   =0x00E778BC
.coef  Tone_1_TBQBSTB1   =0xFF72CB3E
.coef  Tone_1_TBQBSTB2   =0xFFD31BFB
-- fc = 6KHz, fs = 44.1Ksps
-- fc = 7KHz, fs = 44.1Ksps
-- fc = 8KHz, fs = 44.1Ksps
-- fc = 9KHz, fs = 44.1Ksps
-- fc = 10KHz, fs = 44.1Ksps
-- fc = 11KHz, fs = 44.1Ksps
-- fc = 12KHz, fs = 44.1Ksps
-- fc = 13KHz, fs = 44.1Ksps
-- fc = 14KHz, fs = 44.1Ksps
-- fc = 15KHz, fs = 44.1Ksps
-- fs 44.1KHz

-- End of Tone coefficients

.coef  Tone_1_BASSA0_r  =0x00800000     
.coef  Tone_1_TREBLEA0_r =0x00800000    

.data  Tone_1_FLRC_TREBX_D =0x000000000000      -- X
.data  Tone_1_FLRC_TREB1MX_D =0x000000000000    -- 1 - X
.data  Tone_1_FLRC_BASSX_D =0x000000000000      -- X
.data  Tone_1_FLRC_BASS1MX_D =0x000000000000    -- 1 - X
     

-- Port definitions
.data  Tone_1_ToneIn1_D =0x000000000000   
.data  Tone_1_ToneOut1_D =0x000000000000   
.data  Tone_1_VXN1_TrebCh1_D =0x000000000000     
.data  Tone_1_VXN2_TrebCh1_D =0x000000000000     
.data  Tone_1_VYN1_TrebCh1_D =0x000000000000     
.data  Tone_1_VYN2_TrebCh1_D =0x000000000000     
.data  Tone_1_VXN1_BassCh1_D =0x000000000000     
.data  Tone_1_VXN2_BassCh1_D =0x000000000000     
.data  Tone_1_VYN1_BassCh1_D =0x000000000000     
.data  Tone_1_VYN2_BassCh1_D =0x000000000000     
.port Tone_1.Ch1_In Tone_1_ToneIn1_D
.port Tone_1.Ch1_Out Tone_1_ToneOut1_D
.data  Tone_1_ToneOut2_D =0x000000000000   
.data  Tone_1_ToneIn2_D =0x000000000000   
.data  Tone_1_VXN1_TrebCh2_D =0x000000000000     
.data  Tone_1_VXN2_TrebCh2_D =0x000000000000     
.data  Tone_1_VYN1_TrebCh2_D =0x000000000000     
.data  Tone_1_VYN2_TrebCh2_D =0x000000000000     
.data  Tone_1_VXN1_BassCh2_D =0x000000000000     
.data  Tone_1_VXN2_BassCh2_D =0x000000000000     
.data  Tone_1_VYN1_BassCh2_D =0x000000000000     
.data  Tone_1_VYN2_BassCh2_D =0x000000000000     
.port Tone_1.Ch2_In Tone_1_ToneIn2_D
.port Tone_1.Ch2_Out Tone_1_ToneOut2_D

-- correction polynomial a*x^3+b*x^2+c*x+d
.commoncoef  CP_a   =0xFB88C96   -- -0.55820960971142F  -- 0xFFB88C96  
.commoncoef  CP_b   =0x006B2D1E   --  0.83731441231391F  
.commoncoef  CP_c   =0x5C464B     --  1 -0.27910480260249F
-- .coef  Tone_1_CP_d   =0x00000000   --  0.00F
.data  Tone_1_indexT =48.00F  @128   -- 0..48*2 integer
.data  Tone_1_indexB =48.00F  @128+1  -- 0..48*2 integer

.commoncoef  Conv_factor =0x15555  -- 0x15555=(1/48)>>1=(0x2AAAA)>>1
.data Tone_1_switch_flag =0x00000000

-- Read Switch flag to decide which filter coeff be update

CLRACC	| NOP										| NOP																				| NOP																		| NOP
NOP			| ADD(ACC,ZERO,NONE,L) 	| LD(Tone_1_switch_flag ,B)			| NOP																		| NOP
THRU(L)	| NOP										| NOP																				| NOP																		| NOP
THRU(B) | NOP										| NOP																				| NOP																		| NOP
NOP			| COMP(BR,LR)						| NOP																				| NOP																		| NOP
NOP			| NOP										| NOP																				| NOP																		| NOP
BNC(PC)	| NOP										| NOP																				| NOP																		| PCADDR(Tone_1_update_treble)
NOP			| NOP										| NOP																				| NOP																		| NOP
NOP			| NOP										| NOP																				| NOP																		| NOP
NOP			| NOP										| NOP																				| NOP																		| NOP


-- BASS starts at the blow line
-- B1X_D = Index * Conv_factor = Index/48
-- TONE_indexB 0..48; TONE_B1X_D 0..1; TONE_B1X_D is MD in the next line
NOP     | NOP                   | LD(Tone_1_indexB,MD)         | LD(Conv_factor,MC) | NOP  
NOP     | NOP                   | NOP                                      | NOP          			| NOP  
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(CP_c,MC)        | NOP                                                                 
NOP     | NOP                   | NOP                                      | LD(CP_b,MC)        | NOP
NOP     | ADD(ACC,MR,None,B)    | NOP                                      | NOP                                   | NOP                                                                 
-- B = d + c*x
THRU(B) | ADD(ACC,MR,NONE,MC)   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | NOP                   | NOP                                      | LD(CP_a,MC)        | NOP                                                                 
NOP     | ADD(BR,MR,NONE,B)     | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,MC)   | NOP                                      | NOP                                   | NOP                                                                 
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
-- B = d + c*x + x*b*x, a*x, a*x*x, a*x*x*x
NOP     | ADD(ACC,MR,NONE,MC)   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | NOP                   | NOP                                      | LD(ONE,L)                             | NOP                                                                 
-- MC = d + c*x + b*x^2 + a*x^3, 1 -> MD ;
THRU(L) | ADD(BR,MR,NONE,B)   	| NOP                                      | NOP          			   | NOP                                                                 
NEG(B)  | NOP                   | NOP                                      | NOP          			   | ST(B,DATA,Tone_1_FLRC_BASSX_D)                          
CLRACC  | ADD(BR,LR,NONE,B)   	| NOP                                    	 | NOP          			   | NOP                                                                 
NOP     | ADD(ACC,ZERO,NONE,L)  | NOP   																	 | NOP 									 | ST(B,DATA,Tone_1_FLRC_BASS1MX_D)  

-- Generate the coefficients of combined Bass filter
NOP     | NOP                   | LD(Tone_1_FLRC_BASSX_D,MD)   | LD(Tone_1_BBQCUTA1,MC)    | ST(L,DATA,Tone_1_switch_flag)                             
NOP     | NOP                   | LD(Tone_1_FLRC_BASS1MX_D,MD) | LD(Tone_1_BBQBSTA1,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_BASSX_D,MD)   | LD(Tone_1_BBQCUTA2,MC)    | NOP                              
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_BASS1MX_D,MD) | LD(Tone_1_BBQBSTA2,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_BASSX_D,MD)   | LD(Tone_1_BBQCUTB0,MC)    | ST(B,COEF,Tone_1_BASSA1)                                
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_BASS1MX_D,MD) | LD(Tone_1_BBQBSTB0,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_BASSX_D,MD)   | LD(Tone_1_BBQCUTB1,MC)    | ST(B,COEF,Tone_1_BASSA2)                                
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_BASS1MX_D,MD) | LD(Tone_1_BBQBSTB1,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_BASSX_D,MD)   | LD(Tone_1_BBQCUTB2,MC)    | ST(B,COEF,Tone_1_BASSB0)                                
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_BASS1MX_D,MD) | LD(Tone_1_BBQBSTB2,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_BASSX_D,MD)   | LD(Tone_1_BBQCUTA0,MC)    | ST(B,COEF,Tone_1_BASSB1)                                
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_BASS1MX_D,MD) | LD(Tone_1_BBQBSTA0,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,COEF,Tone_1_BASSB2)                                


-- START of Reciprocal calculation for Bass; BASSA0 is computed and stored in MC          
CLRACC  | ADD(ACC,MR,NONE,MC)   | LD(onetenth,MD)                          | LD(ONE,L)                             | NOP    -- MC = A0, MD=1/10;                              
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP    -- L=1;                                           
NOP     | ADD(ACC,MR,NONE,MD)   | LD(one_D,MC)                             | NOP                                   | NOP    -- MD = A0/10, ro=1, LR=-1;                               
-- Compute the reciprocal 1/A0,  x = A0/10
-- if ro<1, ro=1; end   -- skipped on first iteration
-- u = x*ro - 1;
-- Fcn = 1 - u +u^2;
-- r = quant(Fcn*ro, 5:23)                
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                      | ST(MD,data,Tone_1_x) -- ACC=-1;
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP   -- MD=B= u=x*ro-1; LR=1;                                      
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP   --                                                     
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   -- MD = u, MC = u, BR =-u;                                    
NEG(L)  | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP   -- acc = 1 - u, MR=u^2;                                       
CLRACC  | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP   -- B=Fcn= 1-u+u^2= new(r0);                        

-- Recip #2    ; starts at the previous line             
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)     
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP                                    
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP                                                     
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP                                       
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP   
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP    
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP                          
NOP     | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP                                                                 

-- Recip #3 ; starts at the previous line  
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)   
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP                                     
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP                        
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP                               
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP                                  
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP                                 
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP                                               
NOP     | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP                                                                 

-- Recip #4 ; Starts at the previous line
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)  
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP                                     
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP                                             
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP                                  
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP           
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP                             
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP                         
NOP     | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP                                                                 

-- Recip #5 ; Starts at the previous line
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)   
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP                                     
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP  
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP   
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP   
NOP     | NOP                   | NOP                                      | NOP                                   | NOP   
NOP     | ADD(ACC,MR,NONE,MC)   | LD(onetenth,MD)                          | NOP                                   | NOP             
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
clracc  | ADD(ACC,MR,NONE,B)    | NOP                                      | NOP                                   | NOP   -- B=1/BASSA0                                                              
NOP     | NOP                   | NOP                                      | NOP                                   | ST(B,coef,Tone_1_BASSA0_r) 
                       
-- END of Reciprocal calculation for BASS
JMP(PC)	| NOP										| NOP																				| NOP																		| PCADDR(Tone_1_filtering)
NOP			| NOP										| NOP																				| NOP																		| NOP
NOP			| NOP										| NOP																				| NOP																		| NOP
NOP			| NOP										| NOP																				| NOP																		| NOP


Tone_1_update_treble:
--** ** Calculate X and 1-X for Treble Tone BQ Coefficient Creation
-- T1X_D = Index * Conv_factor = Index/48
CLRACC  | NOP                   | LD(Tone_1_indexT,MD)         | LD(Conv_factor,MC) | NOP                                                                 
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
-- TONE_indexT 0..48; TONE_T1X_D 0..1; TONE_T1X is MD in next line
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(CP_c,MC)        | NOP                                                                 
NOP     | NOP                   | NOP                                      | LD(CP_b,MC)        | NOP                                                                 
NOP     | ADD(ACC,MR,None,B)    | NOP                                      | NOP                                   | NOP                                                                 
-- B = d + c*x,  d=0
THRU(B) | ADD(ACC,MR,NONE,MC)   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | NOP                   | NOP                                      | LD(CP_a,MC)        | NOP                                                                 
NOP     | ADD(BR,MR,NONE,B)     | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,MC)   | NOP                                      | NOP                                   | NOP                                                                 
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
-- B = d + c*x + x*b*x, a*x, a*x*x, a*x*x*x
NOP     | ADD(ACC,MR,NONE,MC)   | NOP                                      | NOP                                   | NOP                                                                 
CLRACC  | NOP                   | NOP                                      | LD(ONE,L)          | NOP                                                                 
-- MC = d + c*x + b*x^2 + a*x^3, 1 -> MD ; 
THRU(L) | ADD(BR,MR,NONE,B)     | NOP                                      | NOP                                   | NOP                                                                 
NEG(B)  | NOP                   | NOP                                      | NOP                | ST(B,DATA,Tone_1_FLRC_TREBX_D)                          
NEG(L)  | ADD(BR,LR,NONE,B)     | NOP                                      | NOP                | NOP                                                                 
NOP     | ADD(ACC,LR,NONE,L)    | NOP                                      | NOP          			| ST(B,DATA,Tone_1_FLRC_TREB1MX_D) 

--** ** Calculate combined Treble Biquad Coefficients                       

NOP     | NOP                   | LD(Tone_1_FLRC_TREBX_D,MD)   | LD(Tone_1_TBQCUTA1,MC)    | ST(L,DATA,Tone_1_switch_flag)              
CLRACC  | NOP                   | LD(Tone_1_FLRC_TREB1MX_D,MD) | LD(Tone_1_TBQBSTA1,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_TREBX_D,MD)   | LD(Tone_1_TBQCUTA2,MC)    | NOP                              
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_TREB1MX_D,MD) | LD(Tone_1_TBQBSTA2,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_TREBX_D,MD)   | LD(Tone_1_TBQCUTB0,MC)    | ST(B,COEF,Tone_1_TREBLEA1)                              
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_TREB1MX_D,MD) | LD(Tone_1_TBQBSTB0,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_TREBX_D,MD)   | LD(Tone_1_TBQCUTB1,MC)    | ST(B,COEF,Tone_1_TREBLEA2)                              
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_TREB1MX_D,MD) | LD(Tone_1_TBQBSTB1,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_TREBX_D,MD)   | LD(Tone_1_TBQCUTB2,MC)    | ST(B,COEF,Tone_1_TREBLEB0)                              
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_TREB1MX_D,MD) | LD(Tone_1_TBQBSTB2,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_FLRC_TREBX_D,MD)   | LD(Tone_1_TBQCUTA0,MC)		 | ST(B,COEF,Tone_1_TREBLEB1) 
CLRACC  | ADD(ACC,MR,NONE,B)    | LD(Tone_1_FLRC_TREB1MX_D,MD) | LD(Tone_1_TBQBSTA0,MC)		 | NOP 
NOP     | ADD(ACC,MR,NONE,ACC)  | NOP                                      | NOP          												 | ST(B,COEF,Tone_1_TREBLEB2)  


-- TREBLEA0_r = (roTREBLE/10)*0.1           

CLRACC  | ADD(ACC,MR,NONE,MC)   | LD(onetenth,MD)                          | LD(ONE,L)                             | NOP   
NOP     | NOP                   | NOP                                      | NOP                                   | NOP 
NEG(L)  | ADD(ACC,MR,NONE, MD)  | LD(one_D,MC)                             | NOP                                   | NOP -- MD = A0/10, LR=-1;   
-- Compute the reciprocal 1/A0,  x = A0/10
-- if ro<1, ro=1; end   -- skipped on first iteration
-- u = x*ro - 1;
-- Fcn = 1 - u +u^2;
-- r = quant(Fcn*ro, 5:23)                
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                      | ST(MD,data,Tone_1_x) -- ACC=-1; MD=x
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP   -- MD=B=u=x*ro-1; LR=1;                                      
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP   -- BR= u                                                     
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   -- MD = u, MC = u, BR =-u;                                    
NEG(L)  | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP   -- acc = 1 - u, MR=u^2;                                       
CLRACC  | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP   -- B=Fcn=1-u+u^2= new(r0);                        

-- Recip #2    ; starts at the previous line             
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)   
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP   
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP   
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP   
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP   
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP    
NOP     | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP                                                                 

-- Recip #3 ; starts at the previous line  
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)   
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP                         
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP   
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP  
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP   
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP   
NOP     | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP                                                                 

-- Recip #4 ; Starts at the previous line
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)  
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP   
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP   
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP   
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP  
NEG(L)  | NOP                   | NOP                                      | NOP                                   | NOP   
NOP     | ADD(ACC,MR,NONE,MDB)  | LD(Tone_1_x,MC)              | NOP                                   | NOP                                                                 

-- Recip #5 ; Starts at the previous line
NOP     | ADD(ACC,LR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,coef,Tone_1_ro)   
THRU(L) | ADD(ACC,MR,NONE,MDB)  | NOP                                      | NOP                                   | NOP   
THRU(B) | NOP                   | NOP                                      | NOP                                   | NOP   
NEG(B)  | ADD(BR,ZERO,NONE,MC)  | NOP                                      | NOP                                   | NOP   
NOP     | ADD(BR,LR,NONE,ACC)   | NOP                                      | NOP                                   | NOP  
CLRACC  | ADD(ACC,MR,NONE,MD)   | NOP                                      | LD(Tone_1_ro,MC)          | NOP  
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,MC)   | LD(onetenth,MD)                          | NOP                                   | NOP                   
NOP     | NOP                   | NOP                                      | NOP                                   | NOP   
NOP     | ADD(ACC,MR,NONE, B)   | NOP                                      | NOP                                   | NOP   
NOP     | NOP                   | NOP                                      | NOP                                   | ST(B,coef,Tone_1_TREBLEA0_r)  
                                              
-- END of Reciprocal calculation A0 for TREBLE


Tone_1_filtering:
-- Apply combined Bass and Treble filter to Channel 1                           

NOP     | NOP                   | LD(Tone_1_ToneIn1_D,B)       | NOP                                   | NOP   
CLRACC  | NOP                   | LD(Tone_1_VXN2_BassCh1_D,MD) | LD(Tone_1_BASSB2,MC)      | NOP      -- TREBLEA0_r =roTreble/10 =(10/A0)*0.1                
NOP     | NOP                   | LD(Tone_1_ToneIn1_D,MD)      | LD(Tone_1_BASSB0,MC)      | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VXN1_BassCh1_D,MD) | LD(Tone_1_BASSB1,MC)      | NOP			-- MD = A0/10, ro=1        
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN1_BassCh1_D,MD) | LD(Tone_1_BASSA1,MC)      | ST(MD,DATA,Tone_1_VXN2_BassCh1_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN2_BassCh1_D,MD) | LD(Tone_1_BASSA2,MC)      | ST(MD,DATA,Tone_1_VYN2_BassCh1_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_VXN1_BassCh1_D)                        
NOP     | ADD(ACC,MR,NONE,MDB)  | NOP                                      | LD(Tone_1_BASSA0_r,MC)    | NOP                                                                 
-- Apply the A0 term, MD has the quantized output
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,MDB)  | NOP                                      | LD(Tone_1_TREBLEB0,MC)    | NOP                                                                 
-- Write Y located in B to the VYN1_BassCh1_D
CLRACC  | NOP                   | LD(Tone_1_VXN2_TrebCh1_D,MD) | LD(Tone_1_TREBLEB2,MC)    | ST(B,DATA,Tone_1_VYN1_BassCh1_D)                        
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VXN1_TrebCh1_D,MD) | LD(Tone_1_TREBLEB1,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN1_TrebCh1_D,MD) | LD(Tone_1_TREBLEA1,MC)    | ST(MD,DATA,Tone_1_VXN2_TrebCh1_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN2_TrebCh1_D,MD) | LD(Tone_1_TREBLEA2,MC)    | ST(MD,DATA,Tone_1_VYN2_TrebCh1_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_VXN1_TrebCh1_D)                        
NOP     | ADD(ACC,MR,NONE,MDB)  | NOP                                      | LD(Tone_1_TREBLEA0_r,MC)  | NOP                                                                 
-- Apply the A0 term, MD has the quantized output
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,B)    | NOP                                      | NOP                                   | NOP                                                                 
-- Write Y located in B to the VYN1_BassCh1_D
NOP     | NOP                   | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_ToneOut1_D)                           
NOP     | NOP                   | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_VYN1_TrebCh1_D)                            

-- Apply combined Bass and Treble filter to Channel 2
NOP     | NOP                   | LD(Tone_1_ToneIn2_D,B)       | NOP                                   | NOP                                                                 
NOP     | CLRACC                | LD(Tone_1_VXN2_BassCh2_D,MD) | LD(Tone_1_BASSB2,MC)      | NOP                                                                 
NOP     | NOP                   | LD(Tone_1_ToneIn2_D,MD)      | LD(Tone_1_BASSB0,MC)      | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VXN1_BassCh2_D,MD) | LD(Tone_1_BASSB1,MC)      | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN1_BassCh2_D,MD) | LD(Tone_1_BASSA1,MC)      | ST(MD,DATA,Tone_1_VXN2_BassCh2_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN2_BassCh2_D,MD) | LD(Tone_1_BASSA2,MC)      | ST(MD,DATA,Tone_1_VYN2_BassCh2_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_VXN1_BassCh2_D)                        
NOP     | ADD(ACC,MR,NONE,MDB)  | NOP                                      | LD(Tone_1_BASSA0_r,MC)    | NOP                                                                 
-- Apply the A0 term, MD has the quantized output
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,MDB)  | NOP                                      | LD(Tone_1_TREBLEB0,MC)    | NOP                                                                 
-- Write Y located in B to the VYN1_BassCh1_D
CLRACC  | NOP                   | LD(Tone_1_VXN2_TrebCh2_D,MD) | LD(Tone_1_TREBLEB2,MC)    | ST(B,DATA,Tone_1_VYN1_BassCh2_D)                        
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VXN1_TrebCh2_D,MD) | LD(Tone_1_TREBLEB1,MC)    | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN1_TrebCh2_D,MD) | LD(Tone_1_TREBLEA1,MC)    | ST(MD,DATA,Tone_1_VXN2_TrebCh2_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | LD(Tone_1_VYN2_TrebCh2_D,MD) | LD(Tone_1_TREBLEA2,MC)    | ST(MD,DATA,Tone_1_VYN2_TrebCh2_D)                       
NOP     | ADD(ACC,MR,NONE,ACC)  | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_VXN1_TrebCh2_D)                        
NOP     | ADD(ACC,MR,NONE,MDB)  | NOP                                      | LD(Tone_1_TREBLEA0_r,MC)  | NOP                                                                 
-- Apply the A0 term, MD has the quantized output
NOP     | NOP                   | NOP                                      | NOP                                   | NOP                                                                 
NOP     | ADD(ACC,MR,NONE,B)    | NOP                                      | NOP                                   | NOP                                                                 
-- Write Y located in B to the VYN1_BassCh1_D
NOP     | NOP                   | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_ToneOut2_D)                               
NOP     | NOP                   | NOP                                      | NOP                                   | ST(B,DATA,Tone_1_VYN1_TrebCh2_D)                         










--  Copyright (c) Texas Instruments, Inc.  2006
--  Author:     David Zaucha
--  Date:       11/19/06

--  Version:    4

-- 1-8 Channel Volume DSP  assembly code
--
-- Property values of this instance:
-- InstanceId: Volume_1
-- InputChannels: 2

-- Volume

-- Coefficient Space Used = 2 
-- Data Space Used = 4 
-- Code Space Used = 19 + 2*InputChannels 
-- Cycle Count = 19 + 2*InputChannels 


-- alpha filter time constant 
.commoncoef Gn =0x00008001 
.commoncoef OMGn =0x007F8000 
.commoncoef Trim =0x007FFC00

-- Loudness Variable

.coef Volume_1_Vol1 =0x00000000

--

-- Input
.port Volume_1.Ch1_In Volume_1_VolIn1_D
.coef Volume_1_VG1 @128 =0x00144960 
.data Volume_1_VolIn1_D
-- Output
.port Volume_1.Ch1_Out Volume_1_VolOut1_D
.data Volume_1_VolOut1_D

-- Input
.port Volume_1.Ch2_In Volume_1_VolIn2_D
.data Volume_1_VolIn2_D
-- Output
.port Volume_1.Ch2_Out Volume_1_VolOut2_D
.data Volume_1_VolOut2_D







-- Working values

.data Volume_1_VGT1_D =0x00000000 
.data Volume_1_VGT2_D =0x00000000 
.data Volume_1_VGT3_D =0x00000000 
.data Volume_1_VGT4_D =0x00000000 



-- Convert the coefficient to data

NOP    | CLRACC | NOP | LD(Volume_1_VG1,L)  | NOP
THRU(L) | NOP    | NOP                               | NOP | NOP

--    Volume rate filter
--
--    Pre1_Filt_Vol_Contr = alpha * commanded_vol_level + (1-alpha) * prev_Pre1_Filt_Vol_Contr
--    Pre2_Filt_Vol_Contr = alpha * Pre1_Filt_Vol_Contr + (1-alpha) * prev_Pre2_Filt_Vol_Contr
--    Pre3_Filt_Vol_Contr = alpha * Pre2_Filt_Vol_Contr + (1-alpha) * prev_Pre3_Filt_Vol_Contr
--    Filt_Vol_Cont = alpha * Pre3_Filt_Vol_Contr + (1-alpha) * prev_Filt_Vol_Contr
--
--    Dat_ Out = Data_in * Filt_Vol_Cont
--
NOP | ADD(ACC,LR,NONE,MD)  | NOP                              | LD(Gn,MC)   | NOP                                      
NOP | NOP                  | LD(Volume_1_VGT1_D,MD) | LD(OMGn,MC) | NOP                                      
NOP | ADD(ACC,MR,NONE,ACC) | NOP                              | NOP                            | NOP                                      
NOP | ADD(ACC,MR,NONE,MDB) | NOP                              | LD(Gn,MC)   | NOP                                      
NOP | NOP                  | LD(Volume_1_VGT2_D,MD) | LD(OMGn,MC) | ST(B,DATA,Volume_1_VGT1_D)
NOP | ADD(ACC,MR,NONE,ACC) | NOP                              | NOP                            | NOP                                      
NOP | ADD(ACC,MR,NONE,MDB) | NOP                              | LD(Gn,MC)   | NOP                                      
NOP | NOP                  | LD(Volume_1_VGT3_D,MD) | LD(OMGn,MC) | ST(B,DATA,Volume_1_VGT2_D)
NOP | ADD(ACC,MR,NONE,ACC) | NOP                              | NOP                            | NOP                                      
NOP | ADD(ACC,MR,NONE,MDB) | NOP                              | LD(Gn,MC)   | NOP                                      
NOP | NOP                  | LD(Volume_1_VGT4_D,MD) | LD(OMGn,MC) | ST(B,DATA,Volume_1_VGT3_D)
NOP | ADD(ACC,MR,NONE,ACC) | NOP                              | NOP                            | NOP                                      
NOP | ADD(ACC,MR,NONE,MDB) | NOP                              | LD(Trim,MC) | NOP                                      
NOP | NOP                  | NOP                              | NOP                            | NOP                                      
NOP | ADD(ACC,MR,NONE,ACC) | NOP                              | NOP                            | NOP                                      
-- Adjust the Volume of channel 1
--

NOP | ADD(ACC,ZERO,CLP28,MC) | LD(Volume_1_VolIn1_D,MD) | NOP | ST(B,DATA,Volume_1_VGT4_D)
NOP | ADD(ACC,ZERO,CLP28,B)                 | NOP                 | NOP | NOP                                      
NOP | CLRACC                 | NOP                                | NOP | ST(B,COEF,Volume_1_Vol1)                                      

--
-- Channel 2 Volume
--

-- Code
NOP | ADD(ACC,MR,NONE,B)     | LD(Volume_1_VolIn2_D,MD) | NOP | NOP                                         
NOP | CLRACC                 | NOP                                | NOP | ST(B,DATA,Volume_1_VolOut1_D)
NOP | ADD(ACC,MR,NONE,B)     | NOP                                | NOP | NOP                                         
NOP | CLRACC                 | NOP                                | NOP | ST(B,DATA,Volume_1_VolOut2_D)

--
-- Channel 3 Volume
--

--
-- Channel 4 Volume
--

--
-- Channel 5 Volume
--

--
-- Channel 6 Volume
--

--
-- Channel 7 Volume
--

--
-- Channel 8 Volume
--

NOP | NOP| NOP | NOP | NOP

-- PWM Output (TAS3308 PWM Out)
--
-- Property values of this instance:
-- InstanceId: TAS3308PWMOut_1
-- InputChannels: 2

.port TAS3308PWMOut_1.Ch1_In  PWM1L_D
.port TAS3308PWMOut_1.Ch2_In  PWM1R_D

