-- DSP audio main program

-- The TAS3308 SAP-In and SAP-Out data addresses are fixed by the hardware.
-- SAP Inputs
.data TSDIN1L_D @0x0000 
.data TSDIN1R_D @0x0001 
.data TSDIN2L_D @0x0002 
.data TSDIN2R_D @0x0003 
.data TSDIN3L_D @0x0004 
.data TSDIN3R_D @0x0005 

-- SAP and SPDIF Outputs
.data SDOUT1L_D @0x0006 
.data SDOUT1R_D @0x0007 
.data SDOUT2L_D @0x0008 
.data SDOUT2R_D @0x0009 
.data SPDIFOUTL_D @0x000A 
.data SPDIFOUTR_D @0x000B 

-- ADC Inputs
.data Rsvd_Data_1_D @0x000C 
.data Rsvd_Data_2_D @0x000D 
.data TADCL_D @0x000E 
.data Rsvd_Data_3_D @0x000F 
.data Rsvd_Data_4_D @0x0010 
.data TADCR_D @0x0011 

-- PWM Outputs
.data PWM1L_D @0x0012
.data PWM1R_D @0x0013
.data PWM2L_D @0x0014
.data PWM2R_D @0x0015
.data PWM3L_D @0x0016
.data PWM3R_D @0x0017

-- Reserved Data Area
.data Rsvd_Data_5_D @0x0018 
.data Rsvd_Data_6_D @0x0019 
.data Rsvd_Data_7_D @0x001A 

-- Remappable Input Values
.data SDIN1L_D =0x000000000000 
.data SDIN1R_D =0x000000000000
.data SDIN2L_D =0x000000000000
.data SDIN2R_D =0x000000000000
.data SDIN3L_D =0x000000000000
.data SDIN3R_D =0x000000000000
.data ADCL_D =0x000000000000
.data ADCR_D =0x000000000000

-- Reserved 3308 Addresses
.data Rsvd1 @0x0300
.data Rsvd2 @0x0301
.data Rsvd3 @0x0302

-- Version Information
.coef TAS3308AudioApp_1_Version @0 =2

-- Reserved Coefficient Area
.coef Rsvd_Coef_0 @0x0000
.coef Rsvd_Coef_1 @0x0001 =0x007FF6C6
.coef Rsvd_Coef_2 @0x0002 =0x007FFB63
.coef Rsvd_Coef_3 @0x0003 =0xFF80049D
.coef Rsvd_Coef_4 @0x0004 =0x00800000
.coef Rsvd_Coef_5 @0x0005 =0x00000000
.coef Rsvd_Coef_6 @0x0006 =0x00000000
.coef Rsvd_Coef_7 @0x0007 =0x00000000
.coef Rsvd_Coef_8 @0x0008 =0x00000000
.coef Rsvd_Coef_9 @0x0009 =0x00000000
.coef Rsvd_Coef_A @0x000A =0x00000000
.coef Rsvd_Coef_B @0x000B =0x00000000
.coef Rsvd_Coef_C @0x000C =0x00000000
.coef Rsvd_Coef_D @0x000D =0x00000000
.coef Rsvd_Coef_E @0x000E =0x00000000
.coef Rsvd_Coef_F @0x000F =0x00000000



-- Global coef definition that components can rely on
.coef ONE =1.00F
.coef ZERO =0.0F
.data LFS @0x301

-- Global Coefficient Definitions used by ALL Instances of Multiplexer
.coef MuxSTEP =0x0000001

-- Global definition of Peak to RMS conversion factor
.coef PeakToRMS =0.70710678F 
-- PeakToRMS was changed from 1.10988998F to 0.707...F

-- TIBB Coefficients 
.coef DMIX   =0x00000000  
.coef NDMIX  =0x00800000  
.coef malpha =0xffae833f  
.coef beta   =0x005a8279  
.coef Gho    =0x01000000  

.data one_D  =0x000000800000  -- =0x000000080000  
.data mone_D =0xffffff800000 

-- This routine verifies that the STOP Command is seen. There is a jump to here from the end.
NOP      | NOP                   | NOP               | NOP | NOP                       
STOP_LOOP:
NOP      | NOP                   | NOP               | NOP | NOP                       
STOP(PC) | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
JMP(PC)  | NOP                   | NOP               | NOP | PCADDR(STOP_LOOP)         
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
-- Return from Analog processing
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       

-- SAP IN and SAP OUT Routines merged together. DO1-DO8 is the SAP Out Locations and DI is the SAP in.
NOP      | NOP                   | LD(SDOUT1L_D,L)   | NOP | ST(DI,DATA,TSDIN1L_D,NONE)
THRU(L)  | CLRACC                | LD(SDOUT1R_D,L)   | NOP | ST(DI,DATA,TSDIN1R_D,NONE)
THRU(L)  | ADD(ACC,LR,CLP32,DO1) | LD(SDOUT2L_D,L)   | NOP | ST(DI,DATA,TSDIN2L_D,NONE)
THRU(L)  | ADD(ACC,LR,CLP32,DO2) | LD(SDOUT2R_D,L)   | NOP | ST(DI,DATA,TSDIN2R_D,NONE)
THRU(L)  | ADD(ACC,LR,CLP32,DO3) | LD(SPDIFOUTL_D,L) | NOP | ST(DI,DATA,TSDIN3L_D,NONE)
THRU(L)  | ADD(ACC,LR,CLP32,DO4) | LD(SPDIFOUTR_D,L) | NOP | ST(DI,DATA,TSDIN3R_D,NONE)
THRU(L)  | ADD(ACC,LR,CLP32,DO6) | LD(PWM1L_D,L)     | NOP | NOP                       
THRU(L)  | ADD(ACC,LR,CLP32,DO7) | LD(PWM1R_D,L)     | NOP | NOP                       
THRU(L)  | ADD(ACC,LR,CLP32,DO5) | LD(PWM2L_D,L)     | NOP | NOP                       
THRU(L)  | ADD(ACC,LR,CLP32,DO5) | LD(PWM2R_D,L)     | NOP | NOP                       
THRU(L)  | ADD(ACC,LR,CLP32,DO5) | LD(PWM3L_D,L)     | NOP | NOP                       
THRU(L)  | ADD(ACC,LR,CLP32,DO5) | LD(PWM3R_D,L)     | NOP | NOP                       
THRU(L)  | ADD(ACC,LR,CLP32,DO5) | NOP               | NOP | NOP                       
NOP      | ADD(ACC,LR,CLP32,DO5) | NOP               | NOP | NOP                       


-- DSP flow code, that must be placed in a specific order and connected together with DSP_Links.asm below
.include "DSP_flow.asm"

-- DSP calculation code that may be placed at the end of memory
.include "DSP_calc.asm"

-- This routine is used to Synchronize the data

NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | LD(TSDIN1L_D,L)   | NOP | NOP                       
NOP      | NOP                   | LD(TSDIN1R_D,L)   | NOP | ST(L,DATA,SDIN1L_D)       
NOP      | NOP                   | LD(TSDIN2L_D,L)   | NOP | ST(L,DATA,SDIN1R_D)       
NOP      | NOP                   | LD(TSDIN2R_D,L)   | NOP | ST(L,DATA,SDIN2L_D)       
NOP      | NOP                   | LD(TSDIN3L_D,L)   | NOP | ST(L,DATA,SDIN2R_D)       
NOP      | NOP                   | LD(TSDIN3R_D,L)   | NOP | ST(L,DATA,SDIN3L_D)       
NOP      | NOP                   | LD(TADCL_D,L)     | NOP | ST(L,DATA,SDIN3R_D)       
NOP      | NOP                   | LD(TADCR_D,L)     | NOP | ST(L,DATA,ADCL_D)         
NOP      | NOP                   | NOP               | NOP | ST(L,DATA,ADCR_D)         

-- This routine is put into the End of the code to verify that the STOP Command is seen.

JMP(PC)  | NOP                   | NOP               | NOP | PCADDR(STOP_LOOP)         
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       
NOP      | NOP                   | NOP               | NOP | NOP                       

 
-- link commands that connect components
.include "DSP_links.asm"
 
-- END DSP audio application framework















